explain_readlink_or_die(3)

NAME
explain_readlink_or_die - read value of a symbolic link and report errors
    "read value of a symbolic link and report errors"

SYNOPSIS
#include <libexplain/readlink.h>

ssize_t explain_readlink_or_die(const char *pathname, char *data, size_t data_size);
ssize_t explain_readlink_on_error(const char *pathname, char *data, size_t data_size))

DESCRIPTION
The explain_readlink_or_die function is used to call the readlink(2) system call. On failure an explanation will be printed to stderr, obtained from the explain_readlink(3) function, and then the process terminates by calling exit(EXIT_FAILURE).

The explain_readlink_on_error function is used to call the readlink(2) system call. On failure an explanation will be printed to stderr, obtained from the explain_readlink(3) function, but still returns to the caller.

pathname
    The pathname, exactly as to be passed to the readlink(2) system call.

data
    The data, exactly as to be passed to the readlink(2) system call.

data_size
    The data_size, exactly as to be passed to the readlink(2) system call.

RETURN VALUE
The explain_readlink_or_die function only returns on success, see readlink(2) for more information. On failure, prints an explanation and exits, it does not return.

The explain_readlink_on_error function always returns the value return by the wrapped readlink(2) system call.

EXAMPLE
The explain_readlink_or_die function is intended to be used in a fashion similar to the following example:
    ssize_t result = explain_readlink_or_die(pathname, data, data_size);

SEE ALSO

readlink(2)
    read value of a symbolic link

explain_readlink(3)
    explain readlink(2) errors

exit(2)
    terminate the calling process

COPYRIGHT
libexplain version 1.4
Copyright (C) 2009 Peter Miller